package com.chinaweal.aiccs.common.util;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;
import javax.crypto.spec.IvParameterSpec;
import java.nio.charset.StandardCharsets;
import java.util.Base64;

/**
 * des工具类
 *
 * @author lroyia
 * @since 2025/5/7 14:22
 **/
public class DESUtils {

    private static final String DES_ALGORITHM = "DES"; // 使用DES算法

    /**
     * 加密
     *
     * @param data 源数据
     * @param key  秘钥
     * @return 加密结果
     * @throws Exception 异常
     * @author lroyia
     * @since 2025年5月7日14:23:38
     */
    public static String encrypt(String data, String key) throws Exception {
        byte[] keyBytes = key.getBytes();
        // 初始化向量
        IvParameterSpec iv = new IvParameterSpec(keyBytes);
        DESKeySpec desKey = new DESKeySpec(keyBytes);
        // 创建一个密匙工厂，然后用它把DESKeySpec转换成securekey
        SecretKeyFactory keyFactory = SecretKeyFactory.getInstance(DES_ALGORITHM);
        SecretKey securekey = keyFactory.generateSecret(desKey);
        // Cipher对象实际完成加密操作
        Cipher cipher = Cipher.getInstance("DES/CBC/PKCS5Padding");
        // 用密匙初始化Cipher对象
        cipher.init(Cipher.ENCRYPT_MODE, securekey, iv);
        // 现在，获取数据并加密
        // 正式执行加密操作
        byte[] encryptedBytes = cipher.doFinal(data.getBytes(StandardCharsets.UTF_8));
        return Base64.getEncoder().encodeToString(encryptedBytes);
    }

    /**
     * 解密
     *
     * @param encryptedData 加密了的数据
     * @param key           秘钥
     * @return 加密结果
     * @throws Exception 异常
     * @author lroyia
     * @since 2025年5月7日14:23:38
     */
    public static String decrypt(String encryptedData, String key) throws Exception {
        byte[] keyBytes = key.getBytes();
        // 初始化向量
        IvParameterSpec iv = new IvParameterSpec(keyBytes);
        // 创建一个DESKeySpec对象
        DESKeySpec desKey = new DESKeySpec(keyBytes);
        // 创建一个密匙工厂
        SecretKeyFactory keyFactory = SecretKeyFactory.getInstance(DES_ALGORITHM);
        // 将DESKeySpec对象转换成SecretKey对象
        SecretKey securekey = keyFactory.generateSecret(desKey);
        // Cipher对象实际完成解密操作
        Cipher cipher = Cipher.getInstance("DES/CBC/PKCS5Padding");
        // 用密匙初始化Cipher对象
        cipher.init(Cipher.DECRYPT_MODE, securekey, iv);
        // 真正开始解密操作
        return new String(cipher.doFinal(encryptedData.getBytes(StandardCharsets.UTF_8)));
    }
}
